
/*
 * +==========================================================
 * |	'audio_all.h':
 * |	Music/FM Sound resource mapping defs
 * |
 * |	LoneWolf (Wolf3D/Spear of Destiny engine) source code
 * |    by D.G.Gayev (dgaev@mail.ru), 2004-2005
 * +==========================================================
 *
 */

//
// Sound names & indexes
//

enum {
	STARTPCSOUNDS = 0,
	};

enum SND_nums {
		SND_BEG = 1,

		HITWALLSND = SND_BEG,
		SELECTWPNSND,
		SELECTITEMSND,
		HEARTBEATSND,
		MOVEGUN2SND,
		MOVEGUN1SND,
		NOWAYSND,
		NAZIHITPLAYERSND,
		SCHABBSTHROWSND,
		PLAYERDEATHSND,
		DOGDEATHSND,
		ATKGATLINGSND,
		GETKEYSND,
		NOITEMSND,
		WALK1SND,
		WALK2SND,
		TAKEDAMAGESND,
		GAMEOVERSND,
		OPENDOORSND,
		CLOSEDOORSND,
		DONOTHINGSND,
		HALTSND,
		DEATHSCREAM2SND,
		ATKKNIFESND,
		ATKPISTOLSND,
		DEATHSCREAM3SND,
		ATKMACHINEGUNSND,
		HITENEMYSND,
		SHOOTDOORSND,
		DEATHSCREAM1SND,
		GETMACHINESND,
		GETAMMOSND,
		GETAMMOBOXSND,
		SHOOTSND,
		HEALTH1SND,
		HEALTH2SND,
		BONUS1SND,
		BONUS2SND,
		BONUS3SND,
		GETGATLINGSND,
		ESCPRESSEDSND,
		LEVELDONESND,
		DOGBARKSND,
		ENDBONUS1SND,
		ENDBONUS2SND,
		BONUS1UPSND,
		BONUS4SND,
		PUSHWALLSND,
		NOBONUSSND,
		PERCENT100SND,
		BOSSACTIVESND,
		MUTTISND,
		SCHUTZADSND,
		AHHHGSND,
		DIESND,
		EVASND,
		GUTENTAGSND,
		LEBENSND,
		SCHEISTSND,
		NAZIFIRESND,
		BOSSFIRESND,
		SSFIRESND,
		SLURPIESND,
		TOT_HUNDSND,
		MEINGOTTSND,
		SCHABBSHASND,
		HITLERHASND,
		SPIONSND,
		NEINSOVASSND,
		DOGATTACKSND,
		FLAMETHROWERSND,
		MECHSTEPSND,
		GOOBSSND,
		YEAHSND,
		DEATHSCREAM4SND,
		DEATHSCREAM5SND,
		DEATHSCREAM6SND,
		DEATHSCREAM7SND,
		DEATHSCREAM8SND,
		DEATHSCREAM9SND,
		DONNERSND,
		EINESND,
		ERLAUBENSND,
		KEINSND,
		MEINSND,
		ROSESND,
		MISSILEFIRESND,
		MISSILEHITSND,
		TRANSSIGHTSND,
		TRANSDEATHSND,
		WILHELMSIGHTSND,
		WILHELMDEATHSND,
		UBERDEATHSND,
		KNIGHTSIGHTSND,
		KNIGHTDEATHSND,
		KNIGHTMISSILESND,
		GHOSTSIGHTSND,
		GHOSTFADESND,
		ANGELSIGHTSND,
		ANGELFIRESND,
		ANGELDEATHSND,
		ANGELTIREDSND,
		GETSPEARSND,

		SND_END
    };

//
// Music names & indexes
//
enum MUS_nums {
		MUS_BEG = 1,

		CORNER_MUS,
		DUNGEON_MUS,
		WARMARCH_MUS,
		GETTHEM_MUS,
		HEADACHE_MUS,
		HITLWLTZ_MUS,
		INTROCW3_MUS,
		NAZI_NOR_MUS,
		NAZI_OMI_MUS,
		POW_MUS,
		SALUTE_MUS,
		SEARCHN_MUS,
		SUSPENSE_MUS,
		VICTORS_MUS,
		WONDERIN_MUS,
		FUNKYOU_MUS,
		ENDLEVEL_MUS,
		GOINGAFT_MUS,
		PREGNANT_MUS,
		ULTIMATE_MUS,
		NAZI_RAP_MUS,
		ZEROHOUR_MUS,
		TWELFTH_MUS,
		ROSTER_MUS,
		URAHERO_MUS,
		VICMARCH_MUS,
		PACMAN_MUS,
		XFUNKIE_MUS,
		XDEATH_MUS,
		XTIPTOE_MUS,
		XTHEEND_MUS,
		XEVIL_MUS,
		XJAZNAZI_MUS,
		COPYPRO_MUS,
		XAWARD_MUS,
		XPUTIT_MUS,
		XGETYOU_MUS,
		XTOWER2_MUS,

		MUS_END
	     };

//
// Base offsets
//
extern word STARTADLIBSOUNDS;
extern word STARTMUSIC;

extern word NUMSOUNDS;
extern word NUMSNDCHUNKS;

//
// Sounds & music initialiser
//

typedef struct {
	word N_SNDCHUNKS;
	word N_SOUNDS;
	word STARTMUSIC;

	uint16_t *Order_SND;
	unsigned Order_SND_len;

	uint16_t *Order_MUS;
	unsigned Order_MUS_len;
	} AUD_Init;

//
// Initialise game types
//

extern	AUD_Init
	Init_AUD_WL,			// "audio_wl6.c"
	Init_AUD_SOD;			// "audio_sod.c"

