
/*
 * +==========================================================
 * |	'audio_sod.c':
 * |	Music/FM Sound resource maps
 * |	(Spear of Destiny -- all versions)
 * |
 * |	LoneWolf (Wolf3D/Spear of Destiny engine) source code
 * |    by D.G.Gayev (dgaev@mail.ru), 2004-2005
 * +==========================================================
 *
 */

#include "id_heads.h"

static uint16_t Map_SND_SOD[] = {
	HITWALLSND,
	MISSILEHITSND,
	SELECTITEMSND,
	GHOSTSIGHTSND,
	MOVEGUN2SND,
	MOVEGUN1SND,
	NOWAYSND,
	NAZIHITPLAYERSND,
	MISSILEFIRESND,
	PLAYERDEATHSND,
	DOGDEATHSND,
	ATKGATLINGSND,
	GETKEYSND,
	NOITEMSND,
	WALK1SND,
	WALK2SND,
	TAKEDAMAGESND,
	GAMEOVERSND,
	OPENDOORSND,
	CLOSEDOORSND,
	DONOTHINGSND,
	HALTSND,
	DEATHSCREAM2SND,
	ATKKNIFESND,
	ATKPISTOLSND,
	DEATHSCREAM3SND,
	ATKMACHINEGUNSND,
	HITENEMYSND,
	SHOOTDOORSND,
	DEATHSCREAM1SND,
	GETMACHINESND,
	GETAMMOSND,
	SHOOTSND,
	HEALTH1SND,
	HEALTH2SND,
	BONUS1SND,
	BONUS2SND,
	BONUS3SND,
	GETGATLINGSND,
	ESCPRESSEDSND,
	LEVELDONESND,
	DOGBARKSND,
	ENDBONUS1SND,
	ENDBONUS2SND,
	BONUS1UPSND,
	BONUS4SND,
	PUSHWALLSND,
	NOBONUSSND,
	PERCENT100SND,
	BOSSACTIVESND,
	DEATHSCREAM4SND,
	SCHUTZADSND,
	AHHHGSND,
	DEATHSCREAM5SND,
	DEATHSCREAM7SND,
	DEATHSCREAM8SND,
	LEBENSND,
	DEATHSCREAM6SND,
	NAZIFIRESND,
	BOSSFIRESND,
	SSFIRESND,
	SLURPIESND,
	GHOSTFADESND,
	DEATHSCREAM9SND,
	GETAMMOBOXSND,
	ANGELSIGHTSND,
	SPIONSND,
	NEINSOVASSND,
	DOGATTACKSND,
	ANGELFIRESND,
	TRANSSIGHTSND,
	TRANSDEATHSND,
	WILHELMSIGHTSND,
	WILHELMDEATHSND,
	UBERDEATHSND,
	KNIGHTSIGHTSND,
	KNIGHTDEATHSND,
	ANGELDEATHSND,
	KNIGHTMISSILESND,
	GETSPEARSND,
	ANGELTIREDSND
	};

static uint16_t Map_MUS_SOD[] = {
	XFUNKIE_MUS,
	DUNGEON_MUS,
	XDEATH_MUS,
	GETTHEM_MUS,
	XTIPTOE_MUS,
	GOINGAFT_MUS,
	URAHERO_MUS,
	XTHEEND_MUS,
	NAZI_OMI_MUS,
	POW_MUS,
	TWELFTH_MUS,
	SEARCHN_MUS,
	SUSPENSE_MUS,
	ZEROHOUR_MUS,
	WONDERIN_MUS,
	ULTIMATE_MUS,
	ENDLEVEL_MUS,
	XEVIL_MUS,
	XJAZNAZI_MUS,
	COPYPRO_MUS,
	XAWARD_MUS,
	XPUTIT_MUS,
	XGETYOU_MUS,
	XTOWER2_MUS
	};

//
//
//	Initialise audio data for Spear Of Destiny
//
//

AUD_Init Init_AUD_SOD = {
	267,				// N_SNDCHUNKS
	81,					// N_SOUNDS
	243,				// STARTMUSIC
	
	Map_SND_SOD, lengthof(Map_SND_SOD),
	Map_MUS_SOD, lengthof(Map_MUS_SOD)
	};

