
/*
 * +==========================================================
 * |	'audio_wl6.c':
 * |	Music/FM Sound resource maps
 * |	(Wolf 3D -- all versions)
 * |
 * |	LoneWolf (Wolf3D/Spear of Destiny engine) source code
 * |    by D.G.Gayev (dgaev@mail.ru), 2004-2005
 * +==========================================================
 *
 */

#include "id_heads.h"

static uint16_t Map_SND_WL[] = {
	HITWALLSND,
	SELECTWPNSND,
	SELECTITEMSND,
	HEARTBEATSND,
	MOVEGUN2SND,
	MOVEGUN1SND,
	NOWAYSND,
	NAZIHITPLAYERSND,
	SCHABBSTHROWSND,
	PLAYERDEATHSND,
	DOGDEATHSND,
	ATKGATLINGSND,
	GETKEYSND,
	NOITEMSND,
	WALK1SND,
	WALK2SND,
	TAKEDAMAGESND,
	GAMEOVERSND,
	OPENDOORSND,
	CLOSEDOORSND,
	DONOTHINGSND,
	HALTSND,
	DEATHSCREAM2SND,
	ATKKNIFESND,
	ATKPISTOLSND,
	DEATHSCREAM3SND,
	ATKMACHINEGUNSND,
	HITENEMYSND,
	SHOOTDOORSND,
	DEATHSCREAM1SND,
	GETMACHINESND,
	GETAMMOSND,
	SHOOTSND,
	HEALTH1SND,
	HEALTH2SND,
	BONUS1SND,
	BONUS2SND,
	BONUS3SND,
	GETGATLINGSND,
	ESCPRESSEDSND,
	LEVELDONESND,
	DOGBARKSND,
	ENDBONUS1SND,
	ENDBONUS2SND,
	BONUS1UPSND,
	BONUS4SND,
	PUSHWALLSND,
	NOBONUSSND,
	PERCENT100SND,
	BOSSACTIVESND,
	MUTTISND,
	SCHUTZADSND,
	AHHHGSND,
	DIESND,
	EVASND,
	GUTENTAGSND,
	LEBENSND,
	SCHEISTSND,
	NAZIFIRESND,
	BOSSFIRESND,
	SSFIRESND,
	SLURPIESND,
	TOT_HUNDSND,
	MEINGOTTSND,
	SCHABBSHASND,
	HITLERHASND,
	SPIONSND,
	NEINSOVASSND,
	DOGATTACKSND,
	FLAMETHROWERSND,
	MECHSTEPSND,
	GOOBSSND,
	YEAHSND,
	DEATHSCREAM4SND,
	DEATHSCREAM5SND,
	DEATHSCREAM6SND,
	DEATHSCREAM7SND,
	DEATHSCREAM8SND,
	DEATHSCREAM9SND,
	DONNERSND,
	EINESND,
	ERLAUBENSND,
	KEINSND,
	MEINSND,
	ROSESND,
	MISSILEFIRESND,
	MISSILEHITSND
	};

static uint16_t Map_MUS_WL[] = {
	CORNER_MUS,
	DUNGEON_MUS,
	WARMARCH_MUS,
	GETTHEM_MUS,
	HEADACHE_MUS,
	HITLWLTZ_MUS,
	INTROCW3_MUS,
	NAZI_NOR_MUS,
	NAZI_OMI_MUS,
	POW_MUS,
	SALUTE_MUS,
	SEARCHN_MUS,
	SUSPENSE_MUS,
	VICTORS_MUS,
	WONDERIN_MUS,
	FUNKYOU_MUS,
	ENDLEVEL_MUS,
	GOINGAFT_MUS,
	PREGNANT_MUS,
	ULTIMATE_MUS,
	NAZI_RAP_MUS,
	ZEROHOUR_MUS,
	TWELFTH_MUS,
	ROSTER_MUS,
	URAHERO_MUS,
	VICMARCH_MUS,
	PACMAN_MUS
	};

//
//
//	Initialise audio data for Wolf 3D
//
//

AUD_Init Init_AUD_WL = {
	288,				// N_SNDCHUNKS
	87,					// N_SOUNDS
	261,				// STARTMUSIC
	
	Map_SND_WL, lengthof(Map_SND_WL),
	Map_MUS_WL, lengthof(Map_MUS_WL)
	};

