
/*
 * +==========================================================
 * |	'gfxv_all.h':
 * |	Graphic resource mapping defs
 * |
 * |	LoneWolf (Wolf3D/Spear of Destiny engine) source code
 * |    by D.G.Gayev (dgaev@mail.ru), 2004-2005
 * +==========================================================
 *
 */

//
// Graphics names & indexes
//

enum {
	NUMFONT = 2,			// # of fonts
	NUMTILE8 = 35,			// # of tiles
	};

//
// Graphic resources index
//

enum GFX_nums {
	  GFX_BEG = 1,

		// Common for all game types
		STRUCTPIC = GFX_BEG,
		STARTFONT,
		STARTFONT2,

		STARTPICS,

		// SPEAR BACKDROP
		C_BACKDROPPIC = STARTPICS,
		C_MOUSELBACKPIC,
		C_CURSOR1PIC,
		C_CURSOR2PIC,
		C_NOTSELECTEDPIC,
		C_SELECTEDPIC,

		// SPEAR CONTROL
		C_CUSTOMIZEPIC,
		C_JOY1PIC,
		C_JOY2PIC,
		C_MOUSEPIC,
		C_JOYSTICKPIC,
		C_KEYBOARDPIC,
		C_CONTROLPIC,

		// SPEAR OPTIONS
		C_OPTIONSPIC,

		// SPEAR SOUND
		C_FXTITLEPIC,
		C_DIGITITLEPIC,
		C_MUSICTITLEPIC,

		// NEWGAME
		C_HOWTOUGHPIC,
		C_BABYMODEPIC,
		C_EASYPIC,
		C_NORMALPIC,
		C_HARDPIC,

		// LOADSAVE
		C_DISKLOADING1PIC,
		C_DISKLOADING2PIC,
		C_LOADSAVEDISKPIC,
		C_LOADGAMEPIC,
		C_SAVEGAMEPIC,

		// WOLF EPISODES
		C_EPISODE1PIC,
		C_EPISODE2PIC,
		C_EPISODE3PIC,
		C_EPISODE4PIC,
		C_EPISODE5PIC,
		C_EPISODE6PIC,

		// WOLF README
		H_BJPIC,
		H_CASTLEPIC,
		H_KEYBOARDPIC,
		H_JOYPIC,
		H_HEALPIC,
		H_TREASUREPIC,
		H_GUNPIC,
		H_KEYPIC,
		H_BLAZEPIC,
		H_WEAPON1234PIC,
		H_WOLFLOGOPIC,
		H_VISAPIC,
		H_MCPIC,
		H_IDLOGOPIC,
		H_TOPWINDOWPIC,
		H_LEFTWINDOWPIC,
		H_RIGHTWINDOWPIC,
		H_BOTTOMINFOPIC,
		H_SPEARINFO,

		// HIGHSCORES
		HIGHSCORESPIC,
		C_WONSPEARPIC,		// (SPEAR)

		// WOLF ENDLEVEL
		C_CODEPIC,
		C_TIMECODEPIC,
		C_LEVELPIC,
		C_NAMEPIC,
		C_SCOREPIC,

		// SPEAR ENDGAME
		BJCOLLAPSE1PIC,
		BJCOLLAPSE2PIC,
		BJCOLLAPSE3PIC,
		BJCOLLAPSE4PIC,
		ENDPICPIC,

		// LEVELEND
		L_GUYPIC,
		L_COLONPIC,
		L_NUM0PIC,
		L_NUM1PIC,
		L_NUM2PIC,
		L_NUM3PIC,
		L_NUM4PIC,
		L_NUM5PIC,
		L_NUM6PIC,
		L_NUM7PIC,
		L_NUM8PIC,
		L_NUM9PIC,
		L_PERCENTPIC,
		L_APIC,
		L_BPIC,
		L_CPIC,
		L_DPIC,
		L_EPIC,
		L_FPIC,
		L_GPIC,
		L_HPIC,
		L_IPIC,
		L_JPIC,
		L_KPIC,
		L_LPIC,
		L_MPIC,
		L_NPIC,
		L_OPIC,
		L_PPIC,
		L_QPIC,
		L_RPIC,
		L_SPIC,
		L_TPIC,
		L_UPIC,
		L_VPIC,
		L_WPIC,
		L_XPIC,
		L_YPIC,
		L_ZPIC,
		L_EXPOINTPIC,
		L_APOSTROPHEPIC,
		L_GUY2PIC,
		L_BJWINSPIC,

		// WOLF TITLEPIC
		TITLEPIC,

		// SPEAR TITLEPIC
		TITLE1PIC,
		TITLE2PIC,

		ENDSCREEN11PIC,

		// SPEAR ENDGAME
		ENDSCREEN12PIC,
		ENDSCREEN3PIC,
		ENDSCREEN4PIC,
		ENDSCREEN5PIC,
		ENDSCREEN6PIC,
		ENDSCREEN7PIC,
		ENDSCREEN8PIC,
		ENDSCREEN9PIC,
		STATUSBARPIC,
		PG13PIC,
		CREDITSPIC,

		// SPEAR EASTEREGG
		IDGUYS1PIC,
		IDGUYS2PIC,

		// SPEAR COPYPROT
		COPYPROTTOPPIC,
		COPYPROTBOXPIC,
		BOSSPIC1PIC,
		BOSSPIC2PIC,
		BOSSPIC3PIC,
		BOSSPIC4PIC,

		// LATCHPICS
		KNIFEPIC,
		GUNPIC,
		MACHINEGUNPIC,
		GATLINGGUNPIC,
		NOKEYPIC,
		GOLDKEYPIC,
		SILVERKEYPIC,

		N_BLANKPIC,
		N_0PIC,
		N_1PIC,
		N_2PIC,
		N_3PIC,
		N_4PIC,
		N_5PIC,
		N_6PIC,
		N_7PIC,
		N_8PIC,
		N_9PIC,

		FACE1APIC,
		FACE1BPIC,
		FACE1CPIC,
		FACE2APIC,
		FACE2BPIC,
		FACE2CPIC,
		FACE3APIC,
		FACE3BPIC,
		FACE3CPIC,
		FACE4APIC,
		FACE4BPIC,
		FACE4CPIC,
		FACE5APIC,
		FACE5BPIC,
		FACE5CPIC,
		FACE6APIC,
		FACE6BPIC,
		FACE6CPIC,
		FACE7APIC,
		FACE7BPIC,
		FACE7CPIC,
		FACE8APIC,
		GOTGATLINGPIC,
		GODMODEFACE1PIC,
		GODMODEFACE2PIC,
		GODMODEFACE3PIC,

		BJWAITING1PIC,		// (SPEAR)
		BJWAITING2PIC,		// (SPEAR)
		BJOUCHPIC,				// (SPEAR)
		MUTANTBJPIC,			// (WOLF)

		PAUSEDPIC,
		GETPSYCHEDPIC,

		// TILE8 (special)
		TILE8,

		ORDERSCREEN,
		ERRORSCREEN,

		// PICTURE PALETTES
		TITLEPALETTE,
		END1PALETTE,
		END2PALETTE,
		END3PALETTE,
		END4PALETTE,
		END5PALETTE,
		END6PALETTE,
		END7PALETTE,
		END8PALETTE,
		END9PALETTE,
		IDGUYSPALETTE,		// (SPEAR)

		// DEMOS
		T_DEMO0,
		T_DEMO1,
		T_DEMO2,
		T_DEMO3,

		// ARTICLES (WOLF)
		T_ENDART1,
		T_ENDART2,
		T_ENDART3,
		T_ENDART4,
		T_ENDART5,
		T_ENDART6,
		T_HELPART,

		GFX_END
	 };

//
// Data LUMPs
//

// (Wolfenstein)

extern word README_LUMP_START, README_LUMP_END;
extern word CONTROLS_LUMP_START, CONTROLS_LUMP_END;

// (Spear Of Destiny)

extern word BACKDROP_LUMP_START, BACKDROP_LUMP_END;
extern word CONTROL_LUMP_START, CONTROL_LUMP_END;
extern word OPTIONS_LUMP_START, OPTIONS_LUMP_END;
extern word SOUND_LUMP_START, SOUND_LUMP_END;
extern word NEWGAME_LUMP_START, NEWGAME_LUMP_END;

extern word LOADSAVE_LUMP_START, LOADSAVE_LUMP_END;
extern word HIGHSCORES_LUMP_START, HIGHSCORES_LUMP_END;
extern word ENDGAME_LUMP_START, ENDGAME_LUMP_END;

extern word LEVELEND_LUMP_START, LEVELEND_LUMP_END;
extern word TITLESCREEN_LUMP_START, TITLESCREEN_LUMP_END;
extern word EASTEREGG_LUMP_START, EASTEREGG_LUMP_END;
extern word COPYPROT_LUMP_START, COPYPROT_LUMP_END;
extern word LATCHPICS_LUMP_START, LATCHPICS_LUMP_END;

extern word STARTEXTERNS;

//
// Amount of each data item
//
extern word NUMGRCHUNKS, NUMPICS, NUMEXTERNS;

//
// Graphics initialiser
//

typedef struct {
	word N_GRCHUNKS;
	word N_PICS;
	word N_EXTERNS;

	uint16_t *Order_GFX;
	unsigned Order_GFX_len;

	AssignWord *Values_GFX;
	unsigned Values_GFX_len;
	} GFX_Init;

//
// Initialise game types
//

extern GFX_Init
	Init_GFX_WL1,			// "gfxv_wl1.c"

	Init_GFX_WL6,			// "gfxv_wl6.c"
	Init_GFX_WL6A,		// "gfxv_wl6.c"

	Init_GFX_SDM,			// "gfxv_sdm.c"
	Init_GFX_SOD;			// "gfxv_sod.c"

