
/*
 * +==========================================================
 * |	'gfxv_sod.c':
 * |	Graphic resource maps
 * |	(Spear of Destiny full version)
 * |
 * |	LoneWolf (Wolf3D/Spear of Destiny engine) source code
 * |    by D.G.Gayev (dgaev@mail.ru), 2004-2005
 * +==========================================================
 *
 */

#include "id_heads.h"

static uint16_t Map_GFX_SOD[] = {
	STRUCTPIC,
	STARTFONT,
	STARTFONT2,
	C_BACKDROPPIC,
	C_MOUSELBACKPIC,
	C_CURSOR1PIC,
	C_CURSOR2PIC,
	C_NOTSELECTEDPIC,
	C_SELECTEDPIC,
	C_CUSTOMIZEPIC,
	C_JOY1PIC,
	C_JOY2PIC,
	C_MOUSEPIC,
	C_JOYSTICKPIC,
	C_KEYBOARDPIC,
	C_CONTROLPIC,
	C_OPTIONSPIC,
	C_FXTITLEPIC,
	C_DIGITITLEPIC,
	C_MUSICTITLEPIC,
	C_HOWTOUGHPIC,
	C_BABYMODEPIC,
	C_EASYPIC,
	C_NORMALPIC,
	C_HARDPIC,
	C_DISKLOADING1PIC,
	C_DISKLOADING2PIC,
	C_LOADGAMEPIC,
	C_SAVEGAMEPIC,
	HIGHSCORESPIC,
	C_WONSPEARPIC,
	BJCOLLAPSE1PIC,
	BJCOLLAPSE2PIC,
	BJCOLLAPSE3PIC,
	BJCOLLAPSE4PIC,
	ENDPICPIC,
	L_GUYPIC,
	L_COLONPIC,
	L_NUM0PIC,
	L_NUM1PIC,
	L_NUM2PIC,
	L_NUM3PIC,
	L_NUM4PIC,
	L_NUM5PIC,
	L_NUM6PIC,
	L_NUM7PIC,
	L_NUM8PIC,
	L_NUM9PIC,
	L_PERCENTPIC,
	L_APIC,
	L_BPIC,
	L_CPIC,
	L_DPIC,
	L_EPIC,
	L_FPIC,
	L_GPIC,
	L_HPIC,
	L_IPIC,
	L_JPIC,
	L_KPIC,
	L_LPIC,
	L_MPIC,
	L_NPIC,
	L_OPIC,
	L_PPIC,
	L_QPIC,
	L_RPIC,
	L_SPIC,
	L_TPIC,
	L_UPIC,
	L_VPIC,
	L_WPIC,
	L_XPIC,
	L_YPIC,
	L_ZPIC,
	L_EXPOINTPIC,
	L_APOSTROPHEPIC,
	L_GUY2PIC,
	L_BJWINSPIC,
	TITLE1PIC,
	TITLE2PIC,
	ENDSCREEN11PIC,
	ENDSCREEN12PIC,
	ENDSCREEN3PIC,
	ENDSCREEN4PIC,
	ENDSCREEN5PIC,
	ENDSCREEN6PIC,
	ENDSCREEN7PIC,
	ENDSCREEN8PIC,
	ENDSCREEN9PIC,
	STATUSBARPIC,
	PG13PIC,
	CREDITSPIC,
	IDGUYS1PIC,
	IDGUYS2PIC,
	COPYPROTTOPPIC,
	COPYPROTBOXPIC,
	BOSSPIC1PIC,
	BOSSPIC2PIC,
	BOSSPIC3PIC,
	BOSSPIC4PIC,
	KNIFEPIC,
	GUNPIC,
	MACHINEGUNPIC,
	GATLINGGUNPIC,
	NOKEYPIC,
	GOLDKEYPIC,
	SILVERKEYPIC,
	N_BLANKPIC,
	N_0PIC,
	N_1PIC,
	N_2PIC,
	N_3PIC,
	N_4PIC,
	N_5PIC,
	N_6PIC,
	N_7PIC,
	N_8PIC,
	N_9PIC,
	FACE1APIC,
	FACE1BPIC,
	FACE1CPIC,
	FACE2APIC,
	FACE2BPIC,
	FACE2CPIC,
	FACE3APIC,
	FACE3BPIC,
	FACE3CPIC,
	FACE4APIC,
	FACE4BPIC,
	FACE4CPIC,
	FACE5APIC,
	FACE5BPIC,
	FACE5CPIC,
	FACE6APIC,
	FACE6BPIC,
	FACE6CPIC,
	FACE7APIC,
	FACE7BPIC,
	FACE7CPIC,
	FACE8APIC,
	GOTGATLINGPIC,
	GODMODEFACE1PIC,
	GODMODEFACE2PIC,
	GODMODEFACE3PIC,
	BJWAITING1PIC,
	BJWAITING2PIC,
	BJOUCHPIC,
	PAUSEDPIC,
	GETPSYCHEDPIC,
	TILE8,
	ORDERSCREEN,
	ERRORSCREEN,
	TITLEPALETTE,
	END1PALETTE,
	END2PALETTE,
	END3PALETTE,
	END4PALETTE,
	END5PALETTE,
	END6PALETTE,
	END7PALETTE,
	END8PALETTE,
	END9PALETTE,
	IDGUYSPALETTE,
	T_DEMO0,
	T_DEMO1,
	T_DEMO2,
	T_DEMO3,
	T_ENDART1,
	};

static AssignWord Values_GFX_SOD[] = {
	{ &BACKDROP_LUMP_START,	C_BACKDROPPIC		},
	{ &BACKDROP_LUMP_END,	C_SELECTEDPIC		},

	{ &CONTROL_LUMP_START,	C_CUSTOMIZEPIC		},
	{ &CONTROL_LUMP_END,	C_CONTROLPIC		},

	{ &OPTIONS_LUMP_START,	C_OPTIONSPIC		},
	{ &OPTIONS_LUMP_END,	C_OPTIONSPIC		},

	{ &SOUND_LUMP_START,	C_FXTITLEPIC		},
	{ &SOUND_LUMP_END,	C_MUSICTITLEPIC		},

	{ &NEWGAME_LUMP_START,	C_HOWTOUGHPIC		},
	{ &NEWGAME_LUMP_END,	C_HARDPIC		},

	{ &LOADSAVE_LUMP_START,	C_DISKLOADING1PIC	},
	{ &LOADSAVE_LUMP_END,	C_SAVEGAMEPIC		},

	{ &HIGHSCORES_LUMP_START,	HIGHSCORESPIC	},
	{ &HIGHSCORES_LUMP_END,		C_WONSPEARPIC	},

	{ &ENDGAME_LUMP_START,	BJCOLLAPSE1PIC		},
	{ &ENDGAME_LUMP_END,	ENDPICPIC		},

	{ &LEVELEND_LUMP_START,	L_GUYPIC		},
	{ &LEVELEND_LUMP_END,	L_BJWINSPIC		},

	{ &TITLESCREEN_LUMP_START,	TITLE1PIC	},
	{ &TITLESCREEN_LUMP_END,	TITLE2PIC	},

	{ &EASTEREGG_LUMP_START,	IDGUYS1PIC	},
	{ &EASTEREGG_LUMP_END,		IDGUYS2PIC	},

	{ &COPYPROT_LUMP_START,	COPYPROTTOPPIC		},
	{ &COPYPROT_LUMP_END,	BOSSPIC4PIC		},

	{ &LATCHPICS_LUMP_START,	KNIFEPIC	},
	{ &LATCHPICS_LUMP_END,		GETPSYCHEDPIC	},

	{ &STARTEXTERNS,		ORDERSCREEN	}
	};

//
//
//	Initialise graphic data for Spear of Destiny
//
//

GFX_Init Init_GFX_SOD = {
	169,				// NUMGRCHUNKS
	147,				// NUMPICS
	18,				// NUMEXTERNS
	
	Map_GFX_SOD, lengthof(Map_GFX_SOD),
	Values_GFX_SOD,	lengthof(Values_GFX_SOD)
	};

