
/*
 * +==========================================================
 * |	'id_heads.h':
 * |	Common includes & defs.
 * |
 * |	LoneWolf (Wolf3D/Spear of Destiny engine) source code
 * |    by D.G.Gayev (dgaev@mail.ru), 2004-2005
 * +==========================================================
 *
 */

#ifndef __ID_HEADS_H__
#define __ID_HEADS_H__

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/types.h>
#include <ctype.h>
#include <math.h>

#include "inttypes.h"

#ifdef __cplusplus
typedef bool boolean;
#else
typedef enum { false, true } boolean;
#endif

/* ---------------- */

typedef uint8_t		byte;
typedef uint16_t	word;
typedef uint32_t	longword;
typedef uint32_t	dword;

typedef long fixed;

typedef	struct {
	int x, y;
} Point;

typedef	struct {
	Point ul, lr;
} Rect;

#include "version.h"

#define	lengthof(A)	(sizeof(A) / sizeof(A[0]))

//
// Structure to assign word value
//

typedef struct {
	word *dest;
	word value;
	} AssignWord;

/* ------------------------------------------------------------------------ */

#include "audio_all.h"
#include "gfxv_all.h"

#include "misc.h"

#include "vi_comm.h"
#include "sd_comm.h"

#include "id_ca.h"
#include "id_vh.h"
#include "id_us.h"

/* Quit game (with 'error' message) */
void Quit(char *error, ...);

/* Output diagnostic message 'msg' (with importance 'level') */
void Diag(unsigned level, char *msg, ...);

#define TickBase	70	/* 70Hz per tick */

extern unsigned char *gamepal;

#undef PI
#define PI		3.1415926535897932384626433832795028841971693993751058209749445920

#define	MAXTICS		10
#define DEMOTICS	4

extern int tics;

extern char *GAMENAME;

#endif			// __ID_HEADS_H__

