
/*
 * +==========================================================
 * |	'id_vh.h':
 * |	High-level video primitives (defs)
 * |
 * |	LoneWolf (Wolf3D/Spear of Destiny engine) source code
 * |    by D.G.Gayev (dgaev@mail.ru), 2004-2005
 * +==========================================================
 *
 */

#ifndef __ID_VH_H__
#define __ID_VH_H__

#define WHITE			15
#define BLACK			0

typedef struct
{
	int width, height;
} pictabletype;

extern pictabletype *pictable;

extern byte fontcolor, backcolor;
extern int fontnumber;
extern int px, py;

#define SETFONTCOLOR(f, b) ( fontcolor = f, backcolor = b )

void VW_UpdateScreen();
void VW_UpdateScreenArea (unsigned t, unsigned h, unsigned l, unsigned w);

void VWB_DrawTile8(int x, int y, int tile);
void VWB_DrawPic(int x, int y, int chunknum);
void VWB_DrawPicSync (int x, int y, int chunknum);

extern boolean screenfaded;

#define	VW_Plot(x,y,c)		VL_Plot(x,y,c)

#define VW_Hlin(x,r,y,c)	VL_Hlin(x,y,(r)-(x)+1,c)
#define VW_Vlin(y,b,x,c)	VL_Vlin(x,y,(b)-(y)+1,c)

#define VW_HBar(x,r,y,h,c)	VW_Bar(x,y,(r)-(x),h,c)
#define VW_VBar(y,b,x,w,c)	VW_Bar(x,y,w,(b)-(y),c)

#define VW_FadeIn()		VL_FadeIn(0,255,gamepal,30)
#define VW_FadeOut()		VL_FadeOut(0,255,0,0,0,30)

void	VW_MeasurePropString(char *string, word *width, word *height);

void VW_DrawPropString(char *string);

void VL_FadeOut(int start, int end, int red, int green, int blue, int steps);
void VL_FadeIn(int start, int end, const byte *palette, int steps);

void VL_CacheScreen(int chunk);

void VW_Bar(int x, int y, int width, int height, int color);

void VW_Startup();
void VW_Shutdown();

void VL_FillPalette(int red, int green, int blue);
void VL_Plot(int x, int y, int color);
void VL_Hlin(int x, int y, int width, int color);
void VL_Vlin(int x, int y, int height, int color);
void VL_Bar(int x, int y, int width, int height, int color);

// Scale coordinates
// (from logical to physical)
void VL_Log2Scr (unsigned *cx, unsigned *cy);

#endif
