
/*
 * +==========================================================
 * |	'sd_comm.h':
 * |	Sound output engine: common definitions
 * |
 * |	LoneWolf (Wolf3D/Spear of Destiny engine) source code
 * |    by D.G.Gayev (dgaev@mail.ru), 2004-2005
 * +==========================================================
 *
 */

#ifndef	__SD_COMM_H__
#define	__SD_COMM_H__

typedef	enum	{ sdm_Off, sdm_On } SDMode;
typedef	enum	{ smm_Off, smm_On } SMMode;
typedef	enum	{ sds_Off, sds_On } SDSMode;

extern	SDMode		SoundMode;
extern	SDSMode		DigiMode;
extern	SMMode		MusicMode;

extern void SD_Startup();
extern void SD_Shutdown();

extern void SD_PlayDigi (unsigned page, unsigned length);

extern boolean SD_PlaySound(enum SND_nums sound);

extern void	SD_StopSound(),
		SD_WaitSoundDone(),
		SD_StartMusic(int music),
		SD_MusicOn(),
		SD_MusicOff();

extern boolean SD_SetDigiDevice(SDSMode mode);
extern boolean SD_SetSoundMode(SDMode mode);
extern boolean SD_SetMusicMode(SMMode mode);
		
extern word SD_SoundPlaying();

struct objstruct;

void PlaySoundLocTile (enum SND_nums chunk, fixed tx, fixed ty);
void PlaySoundLocActor(enum SND_nums chunk, struct objstruct *ob);

void UpdateSoundLoc(fixed x, fixed y, int angle);

#endif
