
/*
 * +==========================================================
 * |	'wl_debug.c':
 * |	Debugging and cheat options.
 * |
 * |	LoneWolf (Wolf3D/Spear of Destiny engine) source code
 * |    by D.G.Gayev (dgaev@mail.ru), 2004-2005
 * +==========================================================
 *
 */

#include "wl_def.h"

/*
==================
=
= CountObjects
=
==================
*/

void CountObjects()
{
	int i, total, count, active, inactive;
	objtype	*obj;

	CenterWindow (16,7);
	active = inactive = count = 0;

	US_Print ("Total statics: ");
	total = laststatobj-&statobjlist[0];
	US_PrintUnsigned (total);

	US_Print ("\nIn use statics: ");
	for (i=0;i<total;i++)
		if (statobjlist[i].shapenum != -1)
			count++;

	US_PrintUnsigned (count);

	US_Print ("\nDoors: ");
	US_PrintUnsigned (doornum);

	for (obj=player->next;obj;obj=obj->next)
	{
		if (obj->active)
			active++;
		else
			inactive++;
	}

	US_Print ("\nActive actors: ");
	US_PrintUnsigned (active);

	US_Print ("\nTotal actors: ");
	US_PrintUnsigned (active+inactive);

	US_UpdateWindow();
	IN_Ack();
}

/*
================
=
= PicturePause
=
================
*/

void PicturePause()
{

	FinishPaletteShifts();

	IN_Ack();
	
	if (LastScan != sc_Enter)
	{
		return;
	}

	VL_SetPalette(gamepal);

}

// TODO: is it needed?
void CheckPause() {
if (IN_KeyDown(sc_Alt) && IN_KeyDown(sc_P))
	PicturePause();
}

//
// Logical sprite names
// These must match SPR_ENUM in "wl_def.h"!
//
static char *SPR_names [] = {
		"DEMO",
		"DEATHCAM",

//
// static sprites
//
		"STAT_0", "STAT_1", "STAT_2", "STAT_3",
		"STAT_4", "STAT_5", "STAT_6", "STAT_7",
		"STAT_8", "STAT_9", "STAT_10", "STAT_11",
		"STAT_12", "STAT_13", "STAT_14", "STAT_15",

		"STAT_16", "STAT_17", "STAT_18", "STAT_19",
		"STAT_20", "STAT_21", "STAT_22", "STAT_23",

		"STAT_24", "STAT_25", "STAT_26", "STAT_27",
		"STAT_28", "STAT_29", "STAT_30", "STAT_31",

		"STAT_32", "STAT_33", "STAT_34", "STAT_35",
		"STAT_36", "STAT_37", "STAT_38", "STAT_39",

		"STAT_40", "STAT_41", "STAT_42", "STAT_43",
		"STAT_44", "STAT_45", "STAT_46", "STAT_47",

		"STAT_48", "STAT_49", "STAT_50", "STAT_51",

//
// guard
//
		"GRD_S_1", "GRD_S_2", "GRD_S_3", "GRD_S_4",
		"GRD_S_5", "GRD_S_6", "GRD_S_7", "GRD_S_8",

		"GRD_W1_1", "GRD_W1_2", "GRD_W1_3", "GRD_W1_4",
		"GRD_W1_5", "GRD_W1_6", "GRD_W1_7", "GRD_W1_8",
		"GRD_W2_1", "GRD_W2_2", "GRD_W2_3", "GRD_W2_4",
		"GRD_W2_5", "GRD_W2_6", "GRD_W2_7", "GRD_W2_8",
		"GRD_W3_1", "GRD_W3_2", "GRD_W3_3", "GRD_W3_4",
		"GRD_W3_5", "GRD_W3_6", "GRD_W3_7", "GRD_W3_8",
		"GRD_W4_1", "GRD_W4_2", "GRD_W4_3", "GRD_W4_4",
		"GRD_W4_5", "GRD_W4_6", "GRD_W4_7", "GRD_W4_8",

		"GRD_PAIN_1", "GRD_DIE_1", "GRD_DIE_2", "GRD_DIE_3",
		"GRD_PAIN_2", "GRD_DEAD",
		"GRD_SHOOT1", "GRD_SHOOT2", "GRD_SHOOT3",

//
// dogs
//
		"DOG_W1_1", "DOG_W1_2", "DOG_W1_3", "DOG_W1_4",
		"DOG_W1_5", "DOG_W1_6", "DOG_W1_7", "DOG_W1_8",
		"DOG_W2_1", "DOG_W2_2", "DOG_W2_3", "DOG_W2_4",
		"DOG_W2_5", "DOG_W2_6", "DOG_W2_7", "DOG_W2_8",
		"DOG_W3_1", "DOG_W3_2", "DOG_W3_3", "DOG_W3_4",
		"DOG_W3_5", "DOG_W3_6", "DOG_W3_7", "DOG_W3_8",
		"DOG_W4_1", "DOG_W4_2", "DOG_W4_3", "DOG_W4_4",
		"DOG_W4_5", "DOG_W4_6", "DOG_W4_7", "DOG_W4_8",

		"DOG_DIE_1", "DOG_DIE_2", "DOG_DIE_3", "DOG_DEAD",
		"DOG_JUMP1", "DOG_JUMP2", "DOG_JUMP3",

//
// SS
//
		"SS_S_1", "SS_S_2", "SS_S_3", "SS_S_4",
		"SS_S_5", "SS_S_6", "SS_S_7", "SS_S_8",

		"SS_W1_1", "SS_W1_2", "SS_W1_3", "SS_W1_4",
		"SS_W1_5", "SS_W1_6", "SS_W1_7", "SS_W1_8",
		"SS_W2_1", "SS_W2_2", "SS_W2_3", "SS_W2_4",
		"SS_W2_5", "SS_W2_6", "SS_W2_7", "SS_W2_8",
		"SS_W3_1", "SS_W3_2", "SS_W3_3", "SS_W3_4",
		"SS_W3_5", "SS_W3_6", "SS_W3_7", "SS_W3_8",
		"SS_W4_1", "SS_W4_2", "SS_W4_3", "SS_W4_4",
		"SS_W4_5", "SS_W4_6", "SS_W4_7", "SS_W4_8",

		"SS_PAIN_1", "SS_DIE_1", "SS_DIE_2", "SS_DIE_3",
		"SS_PAIN_2", "SS_DEAD",
		"SS_SHOOT1", "SS_SHOOT2", "SS_SHOOT3",

//
// mutant
//
		"MUT_S_1", "MUT_S_2", "MUT_S_3", "MUT_S_4",
		"MUT_S_5", "MUT_S_6", "MUT_S_7", "MUT_S_8",

		"MUT_W1_1", "MUT_W1_2", "MUT_W1_3", "MUT_W1_4",
		"MUT_W1_5", "MUT_W1_6", "MUT_W1_7", "MUT_W1_8",
		"MUT_W2_1", "MUT_W2_2", "MUT_W2_3", "MUT_W2_4",
		"MUT_W2_5", "MUT_W2_6", "MUT_W2_7", "MUT_W2_8",
		"MUT_W3_1", "MUT_W3_2", "MUT_W3_3", "MUT_W3_4",
		"MUT_W3_5", "MUT_W3_6", "MUT_W3_7", "MUT_W3_8",
		"MUT_W4_1", "MUT_W4_2", "MUT_W4_3", "MUT_W4_4",
		"MUT_W4_5", "MUT_W4_6", "MUT_W4_7", "MUT_W4_8",

		"MUT_PAIN_1", "MUT_DIE_1", "MUT_DIE_2", "MUT_DIE_3",
		"MUT_PAIN_2", "MUT_DIE_4", "MUT_DEAD",
		"MUT_SHOOT1", "MUT_SHOOT2", "MUT_SHOOT3", "MUT_SHOOT4",

//
// officer
//
		"OFC_S_1", "OFC_S_2", "OFC_S_3", "OFC_S_4",
		"OFC_S_5", "OFC_S_6", "OFC_S_7", "OFC_S_8",

		"OFC_W1_1", "OFC_W1_2", "OFC_W1_3", "OFC_W1_4",
		"OFC_W1_5", "OFC_W1_6", "OFC_W1_7", "OFC_W1_8",
		"OFC_W2_1", "OFC_W2_2", "OFC_W2_3", "OFC_W2_4",
		"OFC_W2_5", "OFC_W2_6", "OFC_W2_7", "OFC_W2_8",
		"OFC_W3_1", "OFC_W3_2", "OFC_W3_3", "OFC_W3_4",
		"OFC_W3_5", "OFC_W3_6", "OFC_W3_7", "OFC_W3_8",
		"OFC_W4_1", "OFC_W4_2", "OFC_W4_3", "OFC_W4_4",
		"OFC_W4_5", "OFC_W4_6", "OFC_W4_7", "OFC_W4_8",

		"OFC_PAIN_1", "OFC_DIE_1", "OFC_DIE_2", "OFC_DIE_3",
		"OFC_PAIN_2", "OFC_DIE_4", "OFC_DEAD",
		"OFC_SHOOT1", "OFC_SHOOT2", "OFC_SHOOT3",

//
// ghosts
//
		"BLINKY_W1", "BLINKY_W2", "PINKY_W1", "PINKY_W2",
		"CLYDE_W1", "CLYDE_W2", "INKY_W1", "INKY_W2",

//
// hans
//
		"BOSS_W1", "BOSS_W2", "BOSS_W3", "BOSS_W4",
		"BOSS_SHOOT1", "BOSS_SHOOT2", "BOSS_SHOOT3", "BOSS_DEAD",
		"BOSS_DIE1", "BOSS_DIE2", "BOSS_DIE3",

//
// schabbs
//
		"SCHABB_W1", "SCHABB_W2", "SCHABB_W3", "SCHABB_W4",
		"SCHABB_SHOOT1", "SCHABB_SHOOT2",
		"SCHABB_DIE1", "SCHABB_DIE2", "SCHABB_DIE3", "SCHABB_DEAD",
		"HYPO1", "HYPO2", "HYPO3", "HYPO4",

//
// fake
//
		"FAKE_W1", "FAKE_W2", "FAKE_W3", "FAKE_W4",
		"FAKE_SHOOT", "FIRE1", "FIRE2",
		"FAKE_DIE1", "FAKE_DIE2", "FAKE_DIE3", "FAKE_DIE4",
		"FAKE_DIE5", "FAKE_DEAD",

//
// hitler
//
		"MECHA_W1", "MECHA_W2", "MECHA_W3", "MECHA_W4",
		"MECHA_SHOOT1", "MECHA_SHOOT2", "MECHA_SHOOT3", "MECHA_DEAD",
		"MECHA_DIE1", "MECHA_DIE2", "MECHA_DIE3",

		"HITLER_W1", "HITLER_W2", "HITLER_W3", "HITLER_W4",
		"HITLER_SHOOT1", "HITLER_SHOOT2", "HITLER_SHOOT3", "HITLER_DEAD",
		"HITLER_DIE1", "HITLER_DIE2", "HITLER_DIE3", "HITLER_DIE4",
		"HITLER_DIE5", "HITLER_DIE6", "HITLER_DIE7",

//
// giftmacher
//
		"GIFT_W1", "GIFT_W2", "GIFT_W3", "GIFT_W4",
		"GIFT_SHOOT1", "GIFT_SHOOT2",
		"GIFT_DIE1", "GIFT_DIE2", "GIFT_DIE3", "GIFT_DEAD",

//
// Rocket, smoke and small explosion
//
		"ROCKET_1", "ROCKET_2", "ROCKET_3", "ROCKET_4",
		"ROCKET_5", "ROCKET_6", "ROCKET_7", "ROCKET_8",

		"SMOKE_1", "SMOKE_2", "SMOKE_3", "SMOKE_4",
		"BOOM_1", "BOOM_2", "BOOM_3",

//
// Angel of Death's DeathSparks(tm)
//
		"HROCKET_1", "HROCKET_2", "HROCKET_3", "HROCKET_4",
		"HROCKET_5", "HROCKET_6", "HROCKET_7", "HROCKET_8",

		"HSMOKE_1", "HSMOKE_2", "HSMOKE_3", "HSMOKE_4",
		"HBOOM_1", "HBOOM_2", "HBOOM_3",

		"SPARK1", "SPARK2", "SPARK3", "SPARK4",

//
// gretel
//
		"GRETEL_W1", "GRETEL_W2", "GRETEL_W3", "GRETEL_W4",
		"GRETEL_SHOOT1", "GRETEL_SHOOT2", "GRETEL_SHOOT3", "GRETEL_DEAD",

		"GRETEL_DIE1", "GRETEL_DIE2", "GRETEL_DIE3",

//
// fat face
//
		"FAT_W1", "FAT_W2", "FAT_W3", "FAT_W4",
		"FAT_SHOOT1", "FAT_SHOOT2", "FAT_SHOOT3", "FAT_SHOOT4",

		"FAT_DIE1", "FAT_DIE2", "FAT_DIE3", "FAT_DEAD",

//
// BJ
//
		"BJ_W1", "BJ_W2", "BJ_W3", "BJ_W4",
		"BJ_JUMP1", "BJ_JUMP2", "BJ_JUMP3", "BJ_JUMP4",

//
// THESE ARE FOR 'SPEAR OF DESTINY'
//

//
// Trans Grosse
//
		"TRANS_W1", "TRANS_W2", "TRANS_W3", "TRANS_W4",
		"TRANS_SHOOT1", "TRANS_SHOOT2", "TRANS_SHOOT3", "TRANS_DEAD",

		"TRANS_DIE1", "TRANS_DIE2", "TRANS_DIE3",

//
// Wilhelm
//
		"WILL_W1", "WILL_W2", "WILL_W3", "WILL_W4",
		"WILL_SHOOT1", "WILL_SHOOT2", "WILL_SHOOT3", "WILL_SHOOT4",

		"WILL_DIE1", "WILL_DIE2", "WILL_DIE3", "WILL_DEAD",

//
// UberMutant
//
		"UBER_W1", "UBER_W2", "UBER_W3", "UBER_W4",
		"UBER_SHOOT1", "UBER_SHOOT2", "UBER_SHOOT3", "UBER_SHOOT4",

		"UBER_DIE1", "UBER_DIE2", "UBER_DIE3", "UBER_DIE4",
		"UBER_DEAD",

//
// Death Knight
//
		"DEATH_W1", "DEATH_W2", "DEATH_W3", "DEATH_W4",
		"DEATH_SHOOT1", "DEATH_SHOOT2", "DEATH_SHOOT3", "DEATH_SHOOT4",

		"DEATH_DIE1", "DEATH_DIE2", "DEATH_DIE3", "DEATH_DIE4",
		"DEATH_DIE5", "DEATH_DIE6", "DEATH_DEAD",

//
// Ghost
//
		"SPECTRE_W1", "SPECTRE_W2", "SPECTRE_W3", "SPECTRE_W4",
		"SPECTRE_F1", "SPECTRE_F2", "SPECTRE_F3", "SPECTRE_F4",

//
// Angel of Death
//
		"ANGEL_W1", "ANGEL_W2", "ANGEL_W3", "ANGEL_W4",
		"ANGEL_SHOOT1", "ANGEL_SHOOT2", "ANGEL_TIRED1", "ANGEL_TIRED2",

		"ANGEL_DIE1", "ANGEL_DIE2", "ANGEL_DIE3", "ANGEL_DIE4",
		"ANGEL_DIE5", "ANGEL_DIE6", "ANGEL_DIE7", "ANGEL_DEAD",

//
// player attack frames
//
		"KNIFEREADY",
		"KNIFEATK1", "KNIFEATK2", "KNIFEATK3", "KNIFEATK4",

		"PISTOLREADY",
		"PISTOLATK1", "PISTOLATK2", "PISTOLATK3", "PISTOLATK4",

		"MACHINEREADY",
		"MACHINEATK1", "MACHINEATK2", "MACHINEATK3", "MACHINEATK4",

		"CHAINREADY",
		"CHAINATK1", "CHAINATK2", "CHAINATK3", "CHAINATK4",
		0
};

// Logical sound names
// These must match enum in "audio_all.h"

static char *SND_names [] = {

	"HITWALL",
	"SELECTWPN",
	"SELECTITEM",
	"HEARTBEAT",
	"MOVEGUN2",
	"MOVEGUN1",
	"NOWAY",
	"NAZIHITPLAYER",
	"SCHABBSTHROW",
	"PLAYERDEATH",
	"DOGDEATH",
	"ATKGATLING",
	"GETKEY",
	"NOITEM",
	"WALK1",
	"WALK2",
	"TAKEDAMAGE",
	"GAMEOVER",
	"OPENDOOR",
	"CLOSEDOOR",
	"DONOTHING",
	"HALT",
	"DEATHSCREAM2",
	"ATKKNIFE",
	"ATKPISTOL",
	"DEATHSCREAM3",
	"ATKMACHINEGUN",
	"HITENEMY",
	"SHOOTDOOR",
	"DEATHSCREAM1",
	"GETMACHINE",
	"GETAMMO",
	"GETAMMOBOX",
	"SHOOT",
	"HEALTH1",
	"HEALTH2",
	"BONUS1",
	"BONUS2",
	"BONUS3",
	"GETGATLING",
	"ESCPRESSED",
	"LEVELDONE",
	"DOGBARK",
	"ENDBONUS1",
	"ENDBONUS2",
	"BONUS1UP",
	"BONUS4",
	"PUSHWALL",
	"NOBONUS",
	"PERCENT100",
	"BOSSACTIVE",
	"MUTTI",
	"SCHUTZAD",
	"AHHHG",
	"DIE",
	"EVA",
	"GUTENTAG",
	"LEBEN",
	"SCHEIST",
	"NAZIFIRE",
	"BOSSFIRE",
	"SSFIRE",
	"SLURPIE",
	"TOT_HUND",
	"MEINGOTT",
	"SCHABBSHA",
	"HITLERHA",
	"SPION",
	"NEINSOVAS",
	"DOGATTACK",
	"FLAMETHROWER",
	"MECHSTEP",
	"GOOBS",
	"YEAH",
	"DEATHSCREAM4",
	"DEATHSCREAM5",
	"DEATHSCREAM6",
	"DEATHSCREAM7",
	"DEATHSCREAM8",
	"DEATHSCREAM9",
	"DONNER",
	"EINE",
	"ERLAUBEN",
	"KEIN",
	"MEIN",
	"ROSE",
	"MISSILEFIRE",
	"MISSILEHIT",
	"TRANSSIGHT",
	"TRANSDEATH",
	"WILHELMSIGHT",
	"WILHELMDEATH",
	"UBERDEATH",
	"KNIGHTSIGHT",
	"KNIGHTDEATH",
	"KNIGHTMISSILE",
	"GHOSTSIGHT",
	"GHOSTFADE",
	"ANGELSIGHT",
	"ANGELFIRE",
	"ANGELDEATH",
	"ANGELTIRED",
	"GETSPEAR",
	0
	};

// (This is implemented in "wl_draw.c")

void DrawGraphic (byte *src, boolean sprite,
	int scrx, int scalew, int scry, int scaleh, byte bgshift,
	byte bgcol0, byte bgcol1);

// Draw histogram, using bgcol0/bgcol1
// (assumes array of 'data' contains 'width' entries with 'height' range)
void DrawHisto (unsigned *data,
	int scrx, int width, int scry, int height, byte bgcol0, byte bgcol1);

int LocateSoundPage (unsigned page);
int LocateSound (int val);

//
// Sound histogram building
// (returns false on nonexistent page)
//
boolean build_histogram (unsigned page, unsigned length,
	unsigned *h_data, unsigned h_length, unsigned h_range) {
unsigned i, offset = 0;
byte *dp;
for (i = 0; i != h_length; ++ i)
	h_data [i] = 0;

if (h_length > length) return false;			// (not allowed)

int h_index = 0, h_acc = 0, h_count = 0;

for (i = 0; i != length; ++ i) {
	if (! offset) dp = PM_GetPage (page);

	if (dp == 0) return false;

	h_data [h_index] += dp [offset ++];
	h_count ++;

	if ((h_acc += h_length) >= length) {
		h_data [h_index ++] /= h_count;
		h_count = 0; h_acc -= length;
		}

	if (offset == PMPageSize) offset = 0, ++ page;
	}

if (h_count) h_data [h_index] /= h_count;

for (i = 0; i != h_length; ++ i) {
	h_data [i] = (h_data [i] * h_range) >> 8;
	}

return true;
}	// build_histogram

/*
================
=
= ResourceView
=
================
*/

extern unsigned reverse_sprite_map [SPR_TOTAL];

void US_PrintLabel (char *label) {
if (label)
	{ US_Print ("\""); US_Print (label); US_Print ("\""); }
}	// US_PrintLabel

void US_PrintIndex (int i, int start, int limit) {
if (start <= i && i < limit) {
	US_Print ("#");
	US_PrintUnsigned (i+1 - start);
	US_Print ("/");
	US_PrintUnsigned (limit - start);
	}
}	// US_PrintIndex

void ShowRegion (BBox *bbox, unsigned color,
	unsigned scrx, unsigned scry,
	unsigned scalew, unsigned scaleh) {
if (bbox) {
	unsigned bx = scrx+scalew*bbox->l;
	unsigned by = scry+scaleh*bbox->t;
	unsigned bw = scalew*(bbox->r-bbox->l);
	unsigned bh = scaleh*(bbox->b-bbox->t);

	VL_Bar (bx, by, bw, 1, color);
	VL_Bar (bx, by+bh-1, bw, 1, color);
	VL_Bar (bx, by, 1, bh, color);
	VL_Bar (bx+bw-1, by, 1, bh, color);
	}
}	// ShowRegion

void US_PrintRange (unsigned from, unsigned to) {
US_Print ("(");
US_PrintUnsigned (from);
US_Print ("..");
US_PrintUnsigned (to);
US_Print (")");
}	// US_PrintRange

// Print bounding box dimensions (for sprite)
void US_PrintBox (BBox *box) {
US_PrintRange (box->t, box->b);
US_Print (", ");
US_PrintRange (box->l, box->r);
}	// US_PrintBox

void ResourceView()
{	boolean			done;
	ScanCode		code;
	int			i;

	unsigned scaleh = 1, scalew = 1;
	VL_Log2Scr (&scalew, &scaleh);

	int scrx = xoffset + (viewwidth - GFXWDT*scalew) / 2;
	int scry = yoffset + (viewheight - GFXHGT*scaleh) / 2;

	unsigned histw = 130, histh = 70;
	VL_Log2Scr (&histw, &histh);

	unsigned *histb = (unsigned *) MM_Alloc(sizeof(unsigned) * histw, "histb");

	byte bgcol0 = 0x07, bgcol1 = 0x08;
	byte bgshift = 4;

	boolean show_box = false;

	CenterWindow(20,16);

	for (i = 0, done = false; ! done; )
	{
		US_ClearWindow();

		US_Print(" Page "); US_PrintIndex (i, 0, ChunksInFile);
		US_Print("\n ");

		{
			if (i < PMSpriteStart)
			{ byte *page = PM_GetPage(i);
			US_Print ("(Wall ");
			US_PrintIndex (i, 0, PMSpriteStart);
			US_Print (")");

			//
			// draw the wall tile
			//
			if (page)
			DrawGraphic(page, false,
				scrx, scalew, scry, scaleh,
				bgshift, bgcol0, bgcol1);
			}

			else if (i < PMSoundStart)
			{
			//
			// draw the sprite
			//
			unsigned index = reverse_sprite_map [i - PMSpriteStart];
			BBox *spr_box;
			US_Print ("(Sprite ");
			US_PrintIndex (i, PMSpriteStart, PMSoundStart);
			US_Print (")\n ");

			US_PrintLabel (SPR_names [index]);

			DrawGraphic(GetSprite(index, &spr_box),
				true, scrx, scalew, scry, scaleh,
				bgshift, bgcol0, bgcol1);

			US_Print ("\n\n\n\n\n\n\n\n ");
			US_PrintBox (spr_box);

			if (show_box)
			    ShowRegion (spr_box, 0, scrx, scry, scalew, scaleh);
			}

			else if (i == PMSoundInfo)
			{ unsigned count, npages;


			US_Print("(Sound Info)\n");
			GetAudioTotals (&count, &npages);

			US_Print(" Total sounds: ");
			US_PrintUnsigned (count);

			US_Print("\n Total pages: ");
			US_PrintUnsigned (npages);
			}
			else
			{

			//
			// play the sound
			//
			US_Print ("(Sound ");
			US_PrintIndex (i, PMSoundStart, PMSoundInfo);
			US_Print (")\n ");

			int nsound = LocateSoundPage (i);
			if (nsound >= 0) {
				unsigned page, length;
				unsigned count, npages;
				int index = LocateSound (nsound);

				GetAudioTotals (&count, &npages);
				GetAudioInfo (nsound, &page, &length);

				US_PrintIndex (nsound, 0, count);
				US_Print (" (seg ");
				US_PrintIndex (i, page, page+PMPageNo(length));
				US_Print (")\n\n\n\n\n\n\n\n\n ");
				if (index > 0) US_PrintLabel (SND_names [index-SND_BEG]);

				{ if (build_histogram (page, length, histb, histw, histh))

				{
				DrawHisto (histb,
					xoffset + (viewwidth - histw) / 2, histw,
					yoffset + (viewheight - histh) / 2, histh,
					bgcol0, bgcol1);

				SD_PlayDigi (page, length);
				}
				}
				}
			}
		}

		US_UpdateWindow();

		IN_Ack ();

		code = LastScan;

		IN_ClearKeysDown();

		switch (code)
		{

		case sc_LeftArrow:
			if (i)
				i--;
			break;

		case sc_RightArrow:
			if (i != PMSoundInfo)
				i++;
			break;

		case sc_UpArrow:
			if ((i -= 10) < 0) i = 0;
			break;

		case sc_DownArrow:
			if ((i += 10) > PMSoundInfo) i = PMSoundInfo;
			break;

		case sc_Home:
		case sc_W:	// Walls
			i = 0;
			break;

		case sc_S:	// Sprites
			i = PMSpriteStart;
			break;

		case sc_D:	// Digitized sounds
			i = PMSoundStart;
			break;

		case sc_End:
		case sc_I:	// Digitized sound info
			i = PMSoundInfo;
			break;

		case sc_F3:
			show_box = !show_box;
			break;

		case sc_Escape:
			done = true;
			break;
		}
	}

MM_Free (histb);
}	// ResourceView

// Warp to level 'level'
void LevelWarp (int level, int toplevel) {
if (GAME_WOLF && !level)
	level = 10;

if (level>0 && level<toplevel) {
	gamestate.mapon = level-1;
	playstate = ex_warped;
	}
}	// LevelWarp

// Teleport to map tile (tilex, tiley)
void Teleport (int tilex, int tiley) {
if (0 <= tilex && tilex < MAPWDT &&
    0 <= tiley && tiley < MAPHGT) {
	int half = 1 << (TILESHIFT-1);
	player->x = (tilex << TILESHIFT) + half;
	player->y = (tiley << TILESHIFT) + half;
	player->angle = 0;
	}
}	// Teleport

extern boolean map_all;

/*
================
=
= DebugMenu
=
================
*/

void DebugMenu () {
 int code;

 ClearMemory();
 ClearSplitVWB();

 CA_CacheGrChunk (STARTFONT);
 fontnumber=0;
 SETFONTCOLOR(0,15);

 CenterWindow (32,10);
 US_Print(
 "[A] full ammo * [C] count objects\n"
 "[D] die * [E] end level * [F] facing spot\n"
 "[G] god mode * [H] full health\n"
 "[K] all keys * [L] extra life\n"
 "[N] noclip mode * [O] hurt * [P] pause\n"
 "[Q] quit * [S] slow mode\n"
 "[V] view resources * [W] level warp\n"
 "[X] teleport to"
 );

 US_UpdateWindow();

 IN_Ack ();

 code = LastScan;

 IN_ClearKeysDown();

 ThreeDRefresh();
 DrawPlayBorder();
 VW_UpdateScreen();

 switch (code) {
	case sc_A:		// A = full ammo & weapons
		CenterWindow (20,2);
		US_PrintCentered ("Full ammo + all weapons!");
		GiveAmmo (100);
		GiveWeapon (wp_machinegun);
		GiveWeapon (wp_chaingun);
		break;

	case sc_C:		// C = count objects
		CountObjects ();
		goto finish;

	case sc_D:		// D = die
		playstate = ex_died;
		goto finish;

	case sc_E:		// E = end level
		playstate = ex_completed;
		goto finish;

	case sc_F:		// F = facing spot
		CenterWindow (14,4);
		US_Print ("X: ");
		US_PrintUnsigned (player->x);
		US_Print (" [");
		US_PrintUnsigned (player->x >> TILESHIFT);
		US_Print ("]\nY: ");
		US_PrintUnsigned (player->y);
		US_Print (" [");
		US_PrintUnsigned (player->y >> TILESHIFT);
		US_Print ("]\nA: ");
		US_PrintUnsigned (player->angle);
		break;

	case sc_G:		// G = god mode
		CenterWindow (12,2);
		if (godmode ^= 1)
			US_PrintCentered ("God mode ON");
		else
			US_PrintCentered ("God mode OFF");
		break;

	case sc_H:		// H = full health
		CenterWindow (12,2);
		US_PrintCentered ("Full health!");
		HealSelf (100);
		break;

	case sc_J:		// J = joystick mode
		CenterWindow (12,2);
		if (joystickenabled ^= 1)
			US_PrintCentered ("Joystick ON");
		else
			US_PrintCentered ("Joystick OFF");
		break;

	case sc_K:		// K = all keys
		CenterWindow (10,2);
		US_PrintCentered ("All keys!");
		GiveKey (0);
		GiveKey (1);
		break;

	case sc_L:		// L = extra life
		CenterWindow (12,2);
		US_PrintCentered ("Extra life!");
		GiveExtraMan ();
		break;

	case sc_M:		// M = mouse mode
		CenterWindow (9,2);
		if (mouseenabled ^= 1)
			US_PrintCentered ("Mouse ON");
		else
			US_PrintCentered ("Mouse OFF");
		break;

	case sc_N:		// N = no clip
		CenterWindow (18,2);
		if (noclip^=1)
			US_PrintCentered ("No clipping ON");
		else
			US_PrintCentered ("No clipping OFF");
		break;

	case sc_O:		// O = hurt player (ouch)
		TakeDamage (10,NULL);
		goto finish;

	case sc_P:		// P = pause with no screen disruption
		PicturePause ();
		goto finish;

	case sc_Q:		// Q = fast quit
		Quit("Quick quit!");
		return;

	case sc_S:		// S = slow motion
		CenterWindow (18,2);
		if (singlestep^=1)
			US_PrintCentered ("Slow motion ON");
		else
			US_PrintCentered ("Slow motion OFF");
		break;

	case sc_V:		// V = view resources
		ResourceView ();
		break;

	case sc_W:		// W = warp to level
	{	int esc;

		int toplevel =
		    is_game == GAME_SDM ? 3 : GAME_SPEAR ? 22 : 11;

		CenterWindow(26,1);

		US_Print ("Warp to level (1-");
		US_PrintUnsigned (toplevel-1);
		US_Print ("): ");

		US_UpdateWindow();
		esc = !US_LineInput (px,py,str,NULL,true,2,0);
		if (!esc)
		{	int level = atoi (str);
			LevelWarp (level, toplevel);
		}
		goto finish;
	}

	case sc_X:		// X = teleport to tile
	{	int esc;
		CenterWindow (25,1);

		US_Print (" Teleport to tile [X Y]: ");
		US_UpdateWindow();
		esc = !US_LineInput (px,py,str,NULL,true,5,0);

		if (!esc) {
		int tilex = -1, tiley = -1;
		sscanf (str, "%d%d", &tilex, &tiley);
		Teleport (tilex, tiley);
		}
	}
		break;

	case sc_Y:		// Y = map scroll mode toggle
		CenterWindow (14,2);
		if (map_scroll ^= 1)
			US_PrintCentered ("Map scroll ON");
		else
			US_PrintCentered ("Map scroll OFF");
		break;

	case sc_Z:
		CenterWindow (14,2);
		if (map_all ^= 1)
			US_PrintCentered ("Full map ON");
		else
			US_PrintCentered ("Full map OFF");
		break;

	default:	goto finish;

 }

 US_UpdateWindow();
 DrawPlayBorder();
 IN_Ack();

 finish:
 CA_UnCacheGrChunk(STARTFONT);

}

