
/*
 * +==========================================================
 * |	'wl_latch.c':
 * |	Game status panel.
 * |
 * |	LoneWolf (Wolf3D/Spear of Destiny engine) source code
 * |    by D.G.Gayev (dgaev@mail.ru), 2004-2005
 * +==========================================================
 *
 */

#include "wl_def.h"

/*
=============================================================================

					STATUS WINDOW STUFF

=============================================================================
*/

/*
==================
=
= StatusDrawPic
=
==================
*/

static void StatusDrawPic(unsigned x, unsigned y, unsigned picnum)
{
	VWB_DrawPicSync(x * 8, y + 160, picnum);
}

/*
==================
=
= DrawFace
=
==================
*/

byte face_funny, face_ouch, face_gotgat;

extern objtype *LastAttacker;

void DrawFace() {
int face_spr;

if (face_ouch) {
	face_ouch = 0;
	face_spr = BJOUCHPIC;
	}
else if (face_gotgat) {
	face_gotgat = 0;
	face_spr = GOTGATLINGPIC;
	}
else if (face_funny) {
	face_funny = 0;
	face_spr = BJWAITING1PIC+(US_RndT()&1);
	}

else {
if (gamestate.health) {
	if (GAME_SPEAR && godmode)
		face_spr = GODMODEFACE1PIC;
	else	face_spr = FACE1APIC+3*((MAX_HEALTH-gamestate.health)/16);
	face_spr += gamestate.faceframe;
    } else {
	if (GAME_WOLF && LastAttacker->obclass == needleobj)
		face_spr = MUTANTBJPIC;
	else	face_spr = FACE8APIC;
    }
}

StatusDrawPic (17, 4, face_spr);
}	// DrawFace

/*
===============
=
= LatchNumber
=
= right justifies and pads with blanks
=
===============
*/

static void LatchNumber(int x, int y, int width, long number)
{
	int length, c;

	ltoa(number,str,10);

	length = strlen(str);

	while(length < width)
	{
		StatusDrawPic(x++,y,N_BLANKPIC);
		width--;
	}

	c = length <= width ? 0 : length-width;

	while(c<length)
		StatusDrawPic(x++,y,str[c++]-'0'+ N_0PIC);
}

/*
===============
=
= DrawHealth
=
===============
*/

void DrawHealth()
{
	LatchNumber(21,16,3,gamestate.health);
}

/*
===============
=
= DrawLevel
=
===============
*/

void DrawLevel()
{
int level = gamestate.mapon+1;

if (GAME_SPEAR)
	LatchNumber(2,16,2,level);

else {	LatchNumber(2,16,1,gamestate.episode+1);
	LatchNumber(4,16,1,level == 10 ? 0 : level);
	}
}

/*
===============
=
= DrawLives
=
===============
*/

void DrawLives()
{
	LatchNumber(14,16,1,gamestate.lives);
}

/*
===============
=
= DrawScore
=
===============
*/

void DrawScore()
{
	LatchNumber(6,16,6,gamestate.score);
}

/*
==================
=
= DrawWeapon
=
==================
*/

void DrawWeapon()
{
	StatusDrawPic(32,8,KNIFEPIC+gamestate.weapon);
}

/*
==================
=
= DrawKeys
=
==================
*/

void DrawKey (boolean gold, boolean flag) {
StatusDrawPic (30, gold? 4 : 20,
	flag? (gold? GOLDKEYPIC : SILVERKEYPIC) : NOKEYPIC);
}

void DrawKeys()
{
DrawKey (true,  gamestate.keys & 1);
DrawKey (false, gamestate.keys & 2);
}

/*
===============
=
= DrawAmmo
=
===============
*/

void DrawAmmo()
{
	LatchNumber(26,16,3,gamestate.ammo);
}

